/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.programmation-facile.com/
  Portions created by the Initial Developer are Copyright (C) 2013
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */



/**
 * Le Framework de jeux JavaScript Phaser
 *
Phaser v2.0.5 - http://phaser.io - @photonstorm - (c) 2014 Photon Storm Ltd. 
https://github.com/photonstorm/phaser
http://examples.phaser.io/
 */



/**
 * Les variables du jeu
 * 
 */

var game; 
var S_INFOS = "Nombre de blocs affichés : ";
var nValue;// nombre de blocs affichés sur l'écran
var sTxtInfo;


document.addEventListener("DOMContentLoaded", Main, false); // appel au chargement de la page


/**
 * Fonction principale
 * Appelée au chargement de la page
 * 
 */
function Main()
{
    console.log("Main");

    // creation de la zone de jeu - API Canvas
    game = new Phaser.Game(728,640, Phaser.AUTO, "idGameDiv", {preload:onPreload, create:onCreate, update:onUpdate});
}


/**
 * Préchargement des éléments du jeu
 * 
 * @return {[type]} [description]
 */
function onPreload()
{ 
    game.stage.backgroundColor = '#cccccc';// la couleur de fond du jeu

    game.load.image("grass", "assets/grass.png");// charge les éléments graphiques avec leurs identifiants
    game.load.image("1x1_destroy", "assets/1x1_destroy.png");
    game.load.image("4x1_destroy", "assets/4x1_destroy.png");
    game.load.image("2x1_solid", "assets/2x1_solid.png");
    game.load.image("3x1_destroy", "assets/3x1_destroy.png");
    game.load.image("4x2_solid", "assets/4x2_solid.png");
    game.load.image("totem", "assets/totem.png");
    game.load.image("sensor", "assets/sensor.png");
}



/**
 * Création de la scène du jeu,
 * mise en place des graphismes...
 * 
 * @return {[type]} [description]
 */
function onCreate() 
{
    game.world.bounds = new Phaser.Rectangle(-300, 0, 1328, 640);// création du monde
    
    game.physics.startSystem(Phaser.Physics.P2JS);// ajoute la gestion des lois physiques
 
    game.physics.p2.gravity.y = 250;// ajoute la gravité
    
    // construction du totem
    var grass = game.add.sprite(364, 608, "grass");
    grass.unbreakable=true;// ajoute une propriété indesctructible sur les éléments concernés    
    grass.name="grass";// donne un nom à cet élément, pour le reconnaître plus tard
    game.physics.p2.enable(grass);// active les lois de la physique sur cet élément
    grass.body.static=true;  

    // ajout des blocs
    var brick = game.add.sprite(460, 544, "1x1_destroy");   
    game.physics.p2.enable(brick); 

    brick = game.add.sprite(268, 544, "1x1_destroy");   
    game.physics.p2.enable(brick); 

    brick = game.add.sprite(364, 480, "4x1_destroy");   
    game.physics.p2.enable(brick); 

    brick = game.add.sprite(364, 416, "2x1_solid"); 
    brick.unbreakable=true;
    game.physics.p2.enable(brick); 

    brick = game.add.sprite(332, 352, "3x1_destroy");   
    game.physics.p2.enable(brick); 

    brick = game.add.sprite(364, 256, "4x2_solid"); 
    brick.unbreakable=true;// ajoute une propriété indesctructible sur les éléments concernés    
    game.physics.p2.enable(brick); 

    totem = game.add.sprite(364,128, "totem");
    totem.unbreakable=true;   

    game.physics.p2.enable(totem);// active les lois de la physique sur le totem

    // ajout des bords du jeu
    var sensor = game.add.sprite(-30,320, "sensor");// bord gauche
    sensor.name="sensor";
    game.physics.p2.enable(sensor);  

    sensor.body.static=true;
    sensor.body.data.shapes[0].sensor=true;
    sensor = game.add.sprite(757,320, "sensor");// bord droite
    sensor.name="sensor";
    game.physics.p2.enable(sensor);  
    sensor.body.static=true;        
    sensor.body.data.shapes[0].sensor=true;

    
    totem.body.onBeginContact.add(checkTotemCollision, this);// écouteur pour les collisions sur le totem
    
    game.input.onDown.add(destroyBlock, this);// écouteur des clics de la souris
}


/**
 * Supprime un bloc après le clic de la souris
 * 
 * @param  {[type]} oMouse [description]
 * @return {[type]}         [description]
 */
function destroyBlock(oMouse)
{
    // test de collision de la souris et du bloc
    var bodyClicked = game.physics.p2.hitTest(oMouse.position);
    
    // si un bloc est cliqué
    if(bodyClicked.length!=0)
    {
        // si le bloc peut être détruit
        if(!bodyClicked[0].parent.sprite.unbreakable)
            bodyClicked[0].parent.sprite.kill();// supprime le bloc
    }
}


/**
 * Vérifie les collisions sur le totem
 * 
 * @param  {[type]} body     [description]
 * @param  {[type]} shapeA   [description]
 * @param  {[type]} shapeB   [description]
 * @param  {[type]} equation [description]
 * @return {[type]}          [description]
 */
function checkTotemCollision (body, shapeA, shapeB, equation)
{
    if(body)
    { 
        // vérifie la collision avec les bords du jeu
        if(body.sprite.name=="sensor")
        {
            // ajoute un texte
            var style = { font: "33px Arial", fill: "#ff0044", align: "center" };
            var text = game.add.text(364, 90, "Perdu !! Le Totem est sorti du jeu...", style);  
            text.anchor.set(0.5);

            totem.body.onBeginContact.remove(checkTotemCollision, this);// supprime l'écouteur
        }   

        // vérifie la collision du totem avec l'herbe
        if(body.sprite.name=="grass")
        {
            // ajoute un texte
            var style = { font: "33px Arial", fill: "#5858FA", align: "center" };
            var text = game.add.text(364, 90, "Gagné !! Le totem est sur le sol ;)", style);
            text.anchor.set(0.5);

            totem.body.onBeginContact.remove(checkTotemCollision, this);// supprime l'écouteur
        }
    }
}
                    


/**
 * Appelée en continu pendant le jeu
 * 
 * @return {[type]} [description]
 */
function onUpdate() 
{

}



